/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AddressbooksSynchronizer.
 *
 * The Initial Developer of the Original Code is Günter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Günter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
function doTest() {
  this.promptService.alert(null,'Test', 'doTest');
}

function initialize() {
  var app = Components.classes["@mozilla.org/xre/app-info;1"].
         getService(Components.interfaces.nsIXULAppInfo);
  this.mAppStarttime = Math.round(Date.now()/1000);

  if (Components.classes["@mozilla.org/extensions/manager;1"]) { //Not in TB3.2!!
    var em = Components.classes["@mozilla.org/extensions/manager;1"].
      getService(Components.interfaces.nsIExtensionManager);
    var item = em.getItemForID("addressbookssync@ggbs.de"); //nsIUpdateItem
    this.mVersion=item.version;
    this.mPrefBranch.setCharPref('version',this.mVersion);
  } else {
    this.mVersion='';
    var abs=this;
    Components.utils.import("resource://app/modules/AddonManager.jsm");
    AddonManager.getAddonByID("addressbookssync@ggbs.de",   //asynchron!!
      function(addOn) {
//        dump('AddOn: '+addOn+'\n');
//        for (var prop in addOn) {dump('Prop '+prop+': '+addOn[prop]+'\n');}
        abs.mVersion=addOn.version;
        abs.mPrefBranch.setCharPref('version',abs.mVersion);
dump('AddressbooksSynchronizer Version '+abs.mVersion+'\n');
      });
  }

  this.mNoDirProp=Components.classes["@mozilla.org/addressbook/properties;1"]?false:true;     //since TB3a
  this.mHaveABManager=Components.classes["@mozilla.org/abmanager;1"]?true:false; //since TB3a: nsIAbManager; else nsIAddrBookSession

dump('AddressbooksSynchronizer '+this.mVersion+' appName='+app.name+' appVersion='+app.version+
        '\n   noDirProp='+this.mNoDirProp+' haveABManager='+this.mHaveABManager+'\n');

  this.update();  //Falls was zu updaten ist
  this.cleanup(); //preferences cleanup
  var console = Components.classes["@mozilla.org/consoleservice;1"]
                .getService(Components.interfaces.nsIConsoleService);
  console.logStringMessage('AddressbooksSynchronizer '+this.mVersion+
    ' appName='+app.name+' appVersion='+app.version+'\n');

  try { this.mNT = this.mPrefBranch.getBoolPref("NT"); } catch(e) { this.mNT = false; }

this.debug('App Start##############################################');
    //Used in TB2 and in TB3 if !imap upload
    var observerService =
      Components.classes["@mozilla.org/observer-service;1"]
        .getService(Components.interfaces.nsIObserverService);
    observerService.addObserver(this,"quit-application-requested",false);
    observerService.addObserver(this,"quit-application-granted",false);
    observerService.addObserver(this,"domwindowclosed",false);
    //für true muß observer nsIWeakReference unterstützen
}

function finalize() {
  this.exiting=true;
  this.removeListener();  // remove the listener
this.debug('finalize: autoupload='+this.autoupload);
  if (this.autoupload) {
//dump('onUnload autouploading:'+window.location+"\n");
this.debug('finalize: last window "'+this.lastWindow+'"');
    var app = Components.classes["@mozilla.org/toolkit/app-startup;1"].
        getService(Components.interfaces.nsIAppStartup);
    //definitely needs a window for remote/imap! (Also for local, or message to file fails)
    this.showPopup('upload', null, true, true, false);
//dump('finalize popup shown:'+window.location+"\n");
this.debug('finalize: finalized');
  }
}

function update() {

//// < 0.8.3  : Preferences aus globalem ldap_2.servers.xxx in unseren Bereich verschieben
  var count=new Object();
  var prefs=new Object();
  this.mPrefBranch.getChildList ( "ldap_2.servers", count , prefs );
  if (!count.value) {
//this.promptService.alert(null,'update', 'must update: count='+count.value);

    // get all MAB Files
    var mabs=new Object();
    var cn = this.directory.childNodes;
    while( cn.hasMoreElements() )
    {
      var dir = cn.getNext().QueryInterface(Components.interfaces.nsIAbDirectory);
      var dirProp = this.noDirProp?dir:dir.directoryProperties;
      var dirType = dirProp.dirType;
      if (dirType==this.kPABDirectory) {            // ignore ldap-addressbooks (dirType!=2)
        var prefName = this.noDirProp?dirProp.dirPrefId:dirProp.prefName;
        if (mabs[prefName])
          dump('nsIAbDirectory::childNodes returned double addressbook '+dirProp.fileName+'('+file+')\n');
//          this.promptService.alert(null,'update', 'nsIAbDirectory::childNodes returned double addressbook '+dirProp.fileName);
        else {
//          this.promptService.alert(null,'update', 'move '+dirProp.fileName);
          mabs[prefName]=dirProp;
          if (this.separateupdown) {
            try { sync = this.mGlobalPref.getBoolPref( prefName+".extensions.addressbookssync.up" ); }
              catch(e) { sync=false; }
            this.mPrefBranch.setBoolPref(prefName+'.up', sync);

            try { sync = this.mGlobalPref.getBoolPref( prefName+".extensions.addressbookssync.down" ); }
              catch(e) { sync=false; }
            this.mPrefBranch.setBoolPref(prefName+'.down', sync);
          } else {
            try { sync = this.mGlobalPref.getBoolPref( prefName+".extensions.addressbookssync" ); }
              catch(e) { sync=false; }
            this.mPrefBranch.setBoolPref(prefName+'.up', sync);
            this.mPrefBranch.setBoolPref(prefName+'.down', sync);
          }
          try { sync = this.mGlobalPref.deleteBranch( prefName+".extensions.addressbookssync" ); }
            catch(e) { this.promptService.alert(null,'update', e); }
        }
      }
    } // while
    this.mGlobalPref.savePrefFile(null);  //save to prefs.js
  }
//else this.promptService.alert(null,'update', 'not updating');
//// Ende < 0.8.3

//// <= 0.8.4  : timedupload incorrectly stored as int
  try {
    var val=this.mPrefBranch.getIntPref("timedupload");
    // if this succeeds, we have to update
    this.mPrefBranch.deleteBranch("timedupload");
    this.mPrefBranch.setBoolPref("timedupload", val!=0);
    this.mGlobalPref.savePrefFile(null);  //save to prefs.js
  } catch(e) {  }
//// Ende <= 0.8.4

}

/*
 *  cleanup preferences
 */
function cleanup() {
  count=new Object();
  var prefs=this.mGlobalPref.getChildList("ldap_2.servers", count);
  var done=new Object();
  done['ldap_2.servers.default']=1;
  for (var i=0; i<count.value; i++) {
    var pref=prefs[i];
    pref=pref.replace(/(ldap_2.servers.[^.]+)\..+/,'$1');
    if (done[pref]) continue;
    done[pref]=1;
    try {
      this.mGlobalPref.getCharPref(pref+'.description');  //!!!!
    } catch(e) {
//this.promptService.alert(null, 'test', pref);
      try { var sync = this.mGlobalPref.deleteBranch(pref); }
        catch(e) { this.promptService.alert(null,'update', e); }
    }
  }

  var prefs=this.mPrefBranch.getChildList("ldap_2.servers", count);
    //liefert _ALLE_keys
  for (var i=0; i<count.value; i++) {
    var pref=prefs[i];
    pref=pref.replace(/\.[^.]+$/,'');
    try {
      this.mGlobalPref.getCharPref(pref+'.description');
    } catch(e) {
      try { sync = this.mPrefBranch.deleteBranch(pref); }
        catch(e) { this.promptService.alert(null,'update', e); }
    }
  }

  this.mGlobalPref.savePrefFile(null);  //save to prefs.js

}

/*
 * returns list of mab to be synced
 */
function syncedAddressbooks(direction, singleBook)
{   //direction: up, down, all
  var mabs=new Object();
  var mabsArray=Components.classes["@mozilla.org/supports-array;1"]
         .createInstance(Components.interfaces.nsICollection);

  var cn = this.directory.childNodes;
  var found=false;
  while( cn.hasMoreElements() )
  {
    var dir = cn.getNext().QueryInterface(Components.interfaces.nsIAbDirectory);
    var dirProp = this.noDirProp?dir:dir.directoryProperties;
    if (dirProp.dirType==this.kPABDirectory) {            // ignore ldap-addressbooks (dirType!=2)
      var sync=false;
      if (direction=='all')
        sync=true
      else if (singleBook && dirProp.fileName==singleBook)
        sync=true;
      else if (!singleBook) {
        var prefName = this.noDirProp?dirProp.dirPrefId:dirProp.prefName;
        try { sync = this.mPrefBranch.getBoolPref(prefName+'.'+direction); }
          catch(e) { sync=false; }
      }
      if (sync) {
        found=true;
        var file = dirProp.fileName;
        if (mabs[file])
          // this ist a problem with the preferences, defining a book more than once!
          dump('nsIAbDirectory::childNodes returned double addressbook '+dirProp.fileName+'('+file+')\n');
        else {
          mabs[file]=true;
          mabsArray.AppendElement(dir);
        }
      }
    }
  } // while
  if (!found && direction=='down' && singleBook) { //its a new addressbook
    var sb=Components.classes["@mozilla.org/supports-string;1"]
        .createInstance(Components.interfaces.nsISupportsString);
    sb.data=singleBook;
    mabsArray.AppendElement(sb);
  }
  return mabsArray;
}

/*
 * return address book data structure associated with filename or description (=address book name)
 * TODO: might fail, if called with a mabName and the mabName is in a foreign language!
 *        (see mails with Ivan Kolchagov, to reproduce: change personal address book to bulgarien name)
 */
function getAddressBook( name )
{
  var cn = this.directory.childNodes;
  while( cn.hasMoreElements() )
  {
    var dir = cn.getNext().QueryInterface(Components.interfaces.nsIAbDirectory);
    var dirProp = this.noDirProp?dir:dir.directoryProperties;
    var description=dir.dirName;
    if( dirProp.fileName == name || description == name) {
        return dir;
    }
  } // while
  return null;
} // getAddressBook

/*
 * create new address book
 */
function createAddressBook(name, fileName)
{
  if (this.noDirProp) { //since TB3a
    var uri=this.kMDBDirectoryRoot+fileName;
    try {
dump(name+' created from '+uri+'\n');
      this.directory.createDirectoryByURI(name, uri);
    } catch (e) {
      this.promptService.alert(null, 'ERROR TB3', 'createAddressBook('+name+','+fileName+')\n'+e);
      return null;
    }
  } else {
dump(name+' created from '+fileName+'\n');
    var abProps = Components.classes["@mozilla.org/addressbook/properties;1"].
      createInstance(Components.interfaces.nsIAbDirectoryProperties);
    abProps.description = name;
    abProps.dirType = this.kPABDirectory;
    abProps.fileName = fileName;
//    this.directory.createNewDirectory( abProps );
    try {
      Components.classes["@mozilla.org/addressbook;1"].
        getService(Components.interfaces.nsIAddressBook).
        newAddressBook(abProps);
    } catch(e) {  // might throw NS_ERROR_FILE_ACCESS_DENIED
      this.promptService.alert(null, 'ERROR TB2', 'createAddressBook('+name+','+fileName+')\n'+e);
      return null;
    }
  }
  var dir=this.getAddressBook(fileName);
  dir.lastModifiedDate=this.mAppStarttime; //set to 'not modified'
  return dir;
} // createAddressBook

/*
 * delete an address book
 */
function deleteAddressBook(dir)
{
  // Move focus away from the to be deleted addressbook
    // this has to be done in the AddressBook window :-((
//  try {  SetAbView(this.kPersonalAddressbookURI, false);} catch(e) {   this.promptService.alert(null,'ERROR', e);}

//  dir=dir.QueryInterface(Components.interfaces.nsIAbDirectory);
  try {
    var dirProp = this.noDirProp?dir:dir.directoryProperties;
    var prefName = this.noDirProp?dirProp.dirPrefId:dirProp.prefName;
    var URI=dirProp.URI;
    if (URI==this.kPersonalAddressbookURI ||
        URI==this.kCollectedAddressbookURI)
      return false;

    if (!Components.classes["@mozilla.org/addressbook;1"]) {  //since TB3a
dump('deleting '+URI+'\n');
      this.directory.deleteDirectory(dir);
    } else {
dump('deleting '+URI+' (TB2 version)\n');
      // It seems to be necessary to
      // delete the maillists before deleting the directory
      var lists=dir.childNodes;
      while( lists.hasMoreElements() ) {
        var list = lists.getNext().QueryInterface(Components.interfaces.nsIAbDirectory);
        dir.deleteDirectory(list);
      }
      lists=null;

      var ab = Components.classes["@mozilla.org/addressbook;1"].
                        getService(Components.interfaces.nsIAddressBook);
      var RDF = Components.classes["@mozilla.org/rdf/rdf-service;1"].
                        getService(Components.interfaces.nsIRDFService);
      var parentArray = Components.classes["@mozilla.org/supports-array;1"].
                        createInstance(Components.interfaces.nsISupportsArray);
        var parentDir = RDF.GetResource("moz-abdirectory://").
                        QueryInterface(Components.interfaces.nsIAbDirectory);
        parentArray.AppendElement(parentDir);
      var resourceArray = Components.classes["@mozilla.org/supports-array;1"].
                        createInstance(Components.interfaces.nsISupportsArray);
        var selectedABResource = dir.
                        QueryInterface(Components.interfaces.nsIRDFResource);
        resourceArray.AppendElement(selectedABResource);
      var addressbookDS = RDF.GetDataSource("rdf:addressdirectory");
      ab.deleteAddressBooks(addressbookDS, parentArray, resourceArray);
    }
      //prefName='ldap_2.servers.name' mit name='history', 'pab' oder eigener
    this.mGlobalPref.clearUserPref( prefName+'.position' );  // sometimes remains!?
    this.mGlobalPref.deleteBranch( prefName );

    return true;
  } catch (e) {
this.promptService.alert(null, 'ERROR', 'deleteAddressBook('+dir.dirName+')\n'+e);
    return false;
  }
} // deleteAddressBook

/*
 * get DB for addressbook
 */
function getDB(dir) {
  var curDB;
try {
  if (this.haveABManager) {
    var manager=Components.classes["@mozilla.org/abmanager;1"]
      .getService(Components.interfaces.nsIAbManager);
    var directory = manager.getDirectory(dir.URI);

    var MDB=directory.QueryInterface(Components.interfaces.nsIAbMDBDirectory);
    // MDB.database und MDB.databaseFile sind noch undefined
//dump('MDB: '+MDB+' '+MDB.database+' '+MDB.databaseFile+'\n');
    curDB=MDB.database; //nsIAddrDatabase
  } else {
    var ab = Components.classes["@mozilla.org/addressbook;1"].
      getService(Components.interfaces.nsIAddressBook);
    var dirProp = this.noDirProp?dir:dir.directoryProperties;
//Postbox has no getAbDatabaseFromURI()
    if (ab.getAbDatabaseFromURI)
      curDB=ab.getAbDatabaseFromURI(dirProp.URI); //nsIAddrDatabase
    else {  //Postbox (1.0b13), but should run in TB2 as well
dump('Postbox: no getAbDatabaseFromURI\n');
      var file=dirProp.URI.replace(/.*\/\//,'');
      //var path=this.getDir('ProfD');
      var ds = Components.classes['@mozilla.org/file/directory_service;1']
                .getService(Components.interfaces.nsIProperties);
      var path = ds.get('ProfD',  Components.interfaces.nsIFile)
                  .QueryInterface(Components.interfaces.nsILocalFile);
      path.appendRelativePath(file);
      var db=Components.classes["@mozilla.org/addressbook/carddatabase;1"].
        getService(Components.interfaces.nsIAddrDatabase);
      curDB=db.open(path, false/*don't create*/, true);
    }
  }
} catch(e) {
dump('abs: getDB: '+e+'\n');
}
//dump('curDB '+curDB+'\n');  //dont use in TB2: curDB.dbPath
  return curDB;
}

/*
 * remove Listeners from addressbook
 */
/*
function removeListeners(dir, db) {
// remove listeners, db is a nsIAddrDatabase
//not good, won't be reactivated!
  try {
    var mailLists=dir.addressLists;
    if (!mailLists.Count) {  // since TB3a2: nsIMutableArray (which has .length, not .Count())
      var count=mailLists.length;
      for (var i=0; i<count; i++) {
        var list=mailLists.queryElementAt (i, Components.interfaces.nsIAddrDBListener);
        try { db.removeListener(list); }
        catch(e) {dump('db.remListener on list '+e+'\n');} //exception, wenn kein listener existiert
      }
    } else {                        // nsISupportsArray
      var count=mailLists.Count();
      for (var i=0; i<count; i++) {
        var list = mailLists.GetElementAt(i).QueryInterface(Components.interfaces.nsIAddrDBListener);
        try { db.removeListener(list); }
        catch(e) { dump('db.remListener on list '+e+'\n');} //exception, wenn kein listener existiert
      }
    }
  } catch(e) {
    dump('removeListeners: '+e+'\n');
  }
  try { db.removeListener(dir.QueryInterface(Components.interfaces.nsIAddrDBListener)); }
  catch(e) { dump('db.remListener on dir '+e+'\n'); } //exception, wenn kein listener existiert
dump(count+' listeners removed\n');
}
*/

/*
 * clear an address book
 */
function clearAddressBook(dir)
{
  function deleteLists(ab) {
dump('  delete Lists\n');
    var mdb=ab.QueryInterface(Components.interfaces.nsIAbMDBDirectory);
    var lists=ab.addressLists;
//dump('v');
    if (!lists.Count) {  // since TB3a2: nsIMutableArray (which has .length, not .Count()) {
      var count=lists.length;
      for (var i=count-1; i>=0; i--){ //backwards!
        try {
          var list=lists.queryElementAt(i, Components.interfaces.nsIAbCard);
          var card=list.QueryInterface(Components.interfaces.nsIAbCard);
//dump('  card '+card.primaryEmail+'\n');
//dump('.');
          mdb.removeEmailAddressAt(i);
        } catch(e) {
          var list=lists.queryElementAt(i, Components.interfaces.nsIAbDirectory);
          deleteLists(list);
          list=list.QueryInterface(Components.interfaces.nsIAbMDBDirectory);
          //noscript: list.removeElementsFromAddressList()
//dump('+');
          ab.deleteDirectory(list);
        }
      }
    } else {
      var count=lists.Count();
//dump('--addresslists has '+count+' entries\n');
      for (var i=count-1; i>=0; i--){ //backwards!
        var list=lists.GetElementAt(i);
        if (list instanceof Components.interfaces.nsIAbCard) {
          var card=list.QueryInterface(Components.interfaces.nsIAbCard);
//dump('  card '+card.primaryEmail+'\n');
//dump('.');
          mdb.removeEmailAddressAt(i);
        } else {
          list=list.QueryInterface(Components.interfaces.nsIAbDirectory);
//dump('  list '+list.dirName+'\n');
          deleteLists(list);
          list=list.QueryInterface(Components.interfaces.nsIAbMDBDirectory);
          //noscript: list.removeElementsFromAddressList()
//dump('+');
          ab.deleteDirectory(list);
        }
      }
    }

//dump('^');
  }

  function collectCardsToDelete(ab, use_sa) {
dump('  collect cards to delete\n');
    var cardsE=ab.childCards;
    var cards;
    if (cardsE.hasMoreElements) { // since TB3a
      // cardsE is a nsISimpleEnumerator
      if (!use_sa) { //this is the normal case with TB
        cards = Components.classes["@mozilla.org/array;1"].
          createInstance(Components.interfaces.nsIMutableArray);
        while( cardsE.hasMoreElements() ) {
  //dump('save card '+card.primaryEmail+'\n');
  //dump('.');
          cards.appendElement(cardsE.getNext(), false);
        }
        cards=cards.QueryInterface(Components.interfaces.nsIArray);
      } else { //Postbox wants a nsISupportsArray
        cards = Components.classes["@mozilla.org/supports-array;1"].
          createInstance(Components.interfaces.nsISupportsArray);
        while( cardsE.hasMoreElements() ) {
  //dump('save card '+card.primaryEmail+'\n');
  //dump('.');
          cards.AppendElement(cardsE.getNext());
        }
      }
    } else {
      // cardsE is a nsIEnumerator
      cards = Components.classes["@mozilla.org/supports-array;1"].
        createInstance(Components.interfaces.nsISupportsArray);
        //convert nsIEnumerator to nsISupportsArray (don't try dir.dropCard()!)
      var goon=1;
        // Loop over the cards
      try { cardsE.first() } catch (e) { goon=0; }
      while (goon) {
        var card = cardsE.currentItem().QueryInterface(Components.interfaces.nsIAbCard);
//dump('save card '+card.primaryEmail+'\n');
//dump('.');
        cards.AppendElement(card);
        try { cardsE.next() } catch(e) { goon=0; }
      }
//var count=cards.Count();
//dump('have '+count+' cards to delete\n');
    }
    return cards;
  }

  function forcePurgeDeleted(db) {
dump('  purge cards on deleted list\n');
    var count;
    if (!db.getDeletedCardList) { //since TB3a
      var count=db.deletedCardCount;
      var dList=db.deletedCardList.enumerate();
      while( dList.hasMoreElements() ) {
        var card = dList.getNext().QueryInterface(Components.interfaces.nsIAbCard);
//dump('set lmd on card '+card.primaryEmail+'\n');
        db.setCardValue(card, 'LastModifiedDate', '386d3570' , false);
        count++;
      }
      dList=null;
    } else {
      var countObj=new Object();
      var dListObj=new Object();
      db.getDeletedCardList(countObj, dListObj);
      if (countObj.value) {
        var dList=dListObj.value;
        var count=countObj.value; //dList.Count();
      } else count=0;
//dump(count+' elements on deleted list\n');
      for (var i=0; i<count; i++)
      {
        var card = dList.GetElementAt(i).QueryInterface(Components.interfaces.nsIAbCard);
//        386d3570 = 946681200 = 1.Jan.2000, must not be 0!!
//dump('set lmd on card '+card.primaryEmail+'\n');
        db.setCardValue(card, 'LastModifiedDate', '386d3570' , false);
//wow, with this function, i can set my own values!!
      }
      dListObj=null;
    }
//dump('lmd set on '+count+' cards, they should vanish soon\n');
  }

  //////////////////
  var curDB=this.getDB(dir);
  //this.removeListeners(dir, curDB);
  deleteLists(dir);
//de.ggbs.abs.dumpDir(dir, 'Lists Deleted:');

  try {
    var cards=collectCardsToDelete(dir, false);
dump('  start deleting cards\n');
    try {
      dir.deleteCards(cards);  // delete the cards from the to-be synced addressbook
    } catch(e) { //try Postbox
dump('Try the Postbox version :-(\n');
      cards=collectCardsToDelete(dir, true);
      dir.deleteCards(cards);  // delete the cards from the to-be synced addressbook
    }
dump('  cards deleted\n');
//de.ggbs.abs.dumpDir(dir, 'Cards deleted:');
    cards = null;
  } catch(e) {
    return 'rab_ve: clear addressbook: '+e;
  }


// The cards are not deleted immediately, they are put on a deletedCards Table
// This table can't be purge programmatically, they are automatically purged
// iff more than 50 Cards are in the table and only cards are purged that are
// older than 6 month :-(((
// Therefore I set the LastModifiedDate attribute on the deleted cards to an
// appropriate date (1.1.2000) so they will be deleted later on
  try  {
    forcePurgeDeleted(curDB);
  } catch(e) {
    return 'rab_ve: forcePurgeDeleted: '+e;
  }

  return '';
} // clearAddressBook

/*
 * Fill Addressbook from mab file
 */
function fillAddressBook(dir, file)
{
  function copyCards(db, ab, tab) {
dump('  copy cards\n');
    var tCards=db.enumerateCards(tab);
    if (tCards.hasMoreElements) { //since TB3a:    nsISimpleEnumerator
//dump('    have enumerated the cards\n');
      while(tCards.hasMoreElements()) {
        var tCard = tCards.getNext().QueryInterface(Components.interfaces.nsIAbCard);
        if (!tCard.isMailList) { // only non-maillists
          ab.dropCard(tCard, true); //true is necessary or tb crashes soon after
//dump('insert card '+tCard.primaryEmail+'\n');
//dump('.');
        }
      }
      tCards=null;
    } else {    //nsIEnumerator
      var goon=true;
      var n=0;
      // Loop over the cards
      try { tCards.first() } catch (e) { goon=false; }  //nsIEnumerator
      while (goon) {
        var tCard = tCards.currentItem().QueryInterface(Components.interfaces.nsIAbCard);
        if (!tCard.isMailList) { // only non-maillists (die werden sonst normale cards)
//dump('insert card '+tCard.primaryEmail+'\n');
//dump('.');
          ab.dropCard(tCard, true);
        }
        try { tCards.next() } catch (e) { goon=false; }
      }
      tCards=null;
    }
//dump('\ndone\n');
//de.ggbs.abs.dumpDir(dir, 'Cards copied:');
  }

  function recreateMaillists(ab, tab, db) {
dump('  recreate maillists\n');
    var mailLists=tab.childNodes;
    try  {
      while (mailLists.hasMoreElements()) {
//dump('+');
        var mailList=mailLists.getNext().QueryInterface(Components.interfaces.nsIAbDirectory);
//dump(' recreate '+mailList.dirName+'\n');
        if (!mailList.addressLists.Count) { //since TB3a
          ab.deleteDirectory(mailList);
          ab.addMailList(mailList);
        } else {
          var nMailList = Components.classes["@mozilla.org/addressbook/directoryproperty;1"].
                              createInstance().QueryInterface(Components.interfaces.nsIAbDirectory);
          nMailList.isMailList = true;
          nMailList.dirName = mailList.dirName;
          nMailList.listNickName = mailList.listNickName;
          nMailList.description = mailList.description;
          var total = mailList.addressLists.Count();
          for (var pos=0; pos<total; pos++) {
            var cardproperty = mailList.addressLists.GetElementAt(pos);
            cardproperty = cardproperty.QueryInterface(Components.interfaces.nsIAbCard);
//            var newCardproperty = Components.classes["@mozilla.org/addressbook/cardproperty;1"].
//                createInstance().QueryInterface(Components.interfaces.nsIAbCard);
//            newCardproperty.primaryEmail = cardproperty.primaryEmail;
//            newCardproperty.displayName = cardproperty.displayName;
//            nMailList.addressLists.AppendElement(newCardproperty);
            nMailList.addressLists.AppendElement(cardproperty);
          }
          ab.addMailList(nMailList);
        }
      }
    } catch(e) {
dump('rab_ve: create cards for lists: '+e+'\n');
      return 'rab_ve: create cards for lists: '+e;
    }
    mailLists=null;
//de.ggbs.abs.dumpDir(dir, 'Recreated maillists:');
    return '';
  }

  var curDB=this.getDB(dir);
  //this.removeListeners(dir, curDB);

dump('  open the addressbook database file\n');
  try {
  // open the addressbook database file
    var db=Components.classes["@mozilla.org/addressbook/carddatabase;1"].
      getService(Components.interfaces.nsIAddrDatabase);
    if (!file.isWritable()) { //e.g. a readonly filesystem
      var ds=Components.classes['@mozilla.org/file/directory_service;1']
          .getService(Components.interfaces.nsIProperties);
      var tdir=ds.get('TmpD',  Components.interfaces.nsIFile)
        .QueryInterface(Components.interfaces.nsILocalFile);
      var tempFile=tdir.clone().QueryInterface(Components.interfaces.nsILocalFile);
      var tempName='abstemp.mab';
      tempFile.appendRelativePath(tempName);
      if (tempFile.exists() && tempFile.isFile()) { tempFile.remove(false); }
        //can't use .copyTo as this also copies the permissions  
        // and i can't change them because that throws an error (at least on windows)
      //file.copyTo( tdir, tempName );  //this copies the permissions too
      //tempFile.permission=0x666;      //this throws some kind or error
      this.writeMabData(tempFile, this.readMabData(file, ''));
      file=tempFile;
    }
    var tempDB=db.open(file, true, false) // Shows a message and throws error if file is readonly
      .QueryInterface(Components.interfaces.nsIAddrDatabase);
//dump('opened '+file.path+' -> '+tdb+'\n');
    //tdb.dbPath is undefined (TB2 only)
  } catch(e) {
    return 'rab_ve: open mabfile: '+file.path+' '+file.permissions+' '+e;
  }

  var tempDir=Components.classes['@mozilla.org/rdf/resource-factory;1?name=moz-abmdbdirectory']
          .createInstance(Components.interfaces.nsIAbDirectory);
  try {
    copyCards(tempDB, dir, tempDir);
  } catch(e) {
    return 'rab_ve: copy cards: '+e;
  }

  try {
    var msg;
    if (this.haveABManager) { //since TB3a
      tempDB.getMailingListsFromDB(dir);
      msg=recreateMaillists(dir, dir, curDB);
    } else {
      tempDB.getMailingListsFromDB(tempDir);
      msg=recreateMaillists(dir, tempDir, curDB);
    }
    if (msg) this.promptService.alert(null, 'ERROR', msg);
  } catch(e) {
    this.promptService.alert(null, 'ERROR', 'rab_ve: recreate Maillists: '+e);
    return 'rab_ve: recreate Maillists: '+e;
  }
  tempDir=null;
  tempDB.forceClosed();  //!!!
  curDB.close(true);
//  try { if (tempFile) tempFile.remove(false); } catch(e) { return 'rab_ve: remove Tempfile: '+e; }
  return '';
} // fillAddressBook

/*
 * Fill Addressbook from LDIF file
 */
function LDIFAddressBook(dir, file) {
  var selLocIsHome = true;
  var importService = Components.classes["@mozilla.org/import/import-service;1"].getService().
      QueryInterface(Components.interfaces.nsIImportService);
  var module = importService.GetModule('addressbook', 1);
  var observerService=Components.classes["@mozilla.org/observer-service;1"]
     .getService(Components.interfaces.nsIObserverService);

  var ldifimport = module.GetImportInterface( "addressbook").
      QueryInterface( Components.interfaces.nsIImportGeneric);
  if (ldifimport == null) {
dump('LDIF: No import interface\n');
    var str=Components.classes["@mozilla.org/supports-string;1"].createInstance().
      QueryInterface( Components.interfaces.nsISupportsString);
    str.data='No import interface';
    observerService.notifyObservers(str, "LDIFcomplete", "failed");
    return false;
  }

  ldifimport.SetData("addressLocation", file);

  var map = ldifimport.GetData( "fieldMap");
  if (map != null) {
dump('LDIF: Not a LDIF file!\n');
    var str=Components.classes["@mozilla.org/supports-string;1"].createInstance().
      QueryInterface( Components.interfaces.nsISupportsString);
    str.data='Not a LDIF file';
    observerService.notifyObservers(str, "LDIFcomplete", "failed");
    return false;
  }
  var abURIStr = Components.classes["@mozilla.org/supports-cstring;1"].createInstance().
      QueryInterface( Components.interfaces.nsISupportsCString);
  var dirProp =this.noDirProp?dir:dir.directoryProperties;
  abURIStr.data=dirProp.URI;
  ldifimport.SetData("addressDestination", abURIStr);
//else: created jedesmal ein neues AB mit Namen des LDIF Files

  if (ldifimport.WantsProgress()) {
//dump('wants Progress\n');
    var cont=LDIFAddressBookCont;
    if (ldifimport.BeginImport( cont.successStr, cont.errorStr, selLocIsHome)) {
//dump('start timer\n');
      cont.ldifimport=ldifimport;
      cont.observerService=observerService;
      cont.parent=this;
      var timer = Components.classes["@mozilla.org/timer;1"].
          createInstance(Components.interfaces.nsITimer);
      timer.initWithCallback(cont, 100, Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
//dump('timer started\n');
    } else {
      observerService.notifyObservers(cont.errorStr, "LDIFcomplete", "failed");
    }
  } else {
//dump('no Progress\n');
    if (ldifimport.BeginImport( cont.successStr, cont.errorStr, selLocIsHome))
      observerService.notifyObservers(cont.successStr, "LDIFcomplete", "success");
    else
      observerService.notifyObservers(cont.errorStr, "LDIFcomplete", "failed");
  }
  return true;
}
let LDIFAddressBookCont = {
  successStr: Components.classes["@mozilla.org/supports-string;1"].createInstance().
      QueryInterface( Components.interfaces.nsISupportsString),
  errorStr: Components.classes["@mozilla.org/supports-string;1"].createInstance().
      QueryInterface( Components.interfaces.nsISupportsString),
  ldifimport: null,
  observerService: null,
  importSuccess: false,
  parent: null,

  notify: function(timer)
  {
//dump('timer called\n');
    let clear = true;
    let pcnt;

    if (this.ldifimport) {
//dump('continueImport: have interface\n');

      if (!this.ldifimport.ContinueImport()) {
//dump('continueImport: not continue\n');
        this.importSuccess = false;
        timer.cancel();
//dump('LDIF: Import failed: '+this.errorStr+'\n');
        this.observerService.notifyObservers(this.errorStr, "LDIFcomplete", "failed");
      }
      else if ((pcnt = this.ldifimport.GetProgress()) < 100) {
//dump('continueImport: GetProgress='+pcnt+'\n');
        clear = false;
      }
      else {
        timer.cancel();
        this.importSuccess = true;
//dump('LDIF: finished: '+this.successStr+'\n');
//       this.parent.promptService.alert(null, 'INFO', 'LDIF: Import finished: '+this.successStr);
        this.observerService.notifyObservers(this.successStr, "LDIFcomplete", "success");
      }
    }
    if (clear) {
      this.ldifimport = null;
    }
  }
}

/*
 * generate external filename for address book
 */
function externalFilename(dir) {
  var dirProp = this.noDirProp?dir:dir.directoryProperties;
  var externalFilename;
  var prefName = this.noDirProp?dirProp.dirPrefId:dirProp.prefName;
  try { externalFilename = this.mPrefBranch.getCharPref(prefName+'.filename'); }
  catch(e) {
    var uri = dirProp.URI;
    if (uri!=this.kPersonalAddressbookURI && uri!=this.kCollectedAddressbookURI)
      externalFilename = dir.dirName+'.mab';
    else
      externalFilename = '_tb_'+dirProp.fileName;
  }
//dump('get external filename '+dir.dirName+'->'+externalFilename+'\n');
  return externalFilename;
}
function setExternalFilename(dir, externalFilename) {
  var dirProp = this.noDirProp?dir:dir.directoryProperties;
  var prefName = this.noDirProp?dirProp.dirPrefId:dirProp.prefName;
  if (!externalFilename)
    this.mPrefBranch.clearUserPref(prefName+'.filename', externalFilename);
  else
    this.mPrefBranch.setCharPref(prefName+'.filename', externalFilename);
//dump('set external filename '+dir.dirName+'->'+externalFilename+'\n');
  return externalFilename;
}

function addListener() {
  var addrbookSession;
  sessionListener.abs=this;
dump('abs: addListener\n');
  if (this.haveABManager) {
    var addrbookSession=Components.classes["@mozilla.org/abmanager;1"].
            getService(Components.interfaces.nsIAbManager);
    addrbookSession.addAddressBookListener(
      sessionListener,
//        Components.interfaces.nsIAbListener.itemAdded ||
//        Components.interfaces.nsIAbListener.directoryItemRemoved ||
//        Components.interfaces.nsIAbListener.directoryRemoved ||
//        Components.interfaces.nsIAbListener.itemChanged ||
        Components.interfaces.nsIAbListener.all);
  } else {
    var addrbookSession = Components.classes["@mozilla.org/addressbook/services/session;1"].
            getService(Components.interfaces.nsIAddrBookSession);
    addrbookSession.addAddressBookListener(
      sessionListener,
//        Components.interfaces.nsIAddrBookSession.added ||
//        Components.interfaces.nsIAddrBookSession.directoryItemRemoved ||
//        Components.interfaces.nsIAddrBookSession.directoryRemoved ||
//        Components.interfaces.nsIAddrBookSession.changed ||
        Components.interfaces.nsIAddrBookSession.all);
  }
}

function removeListener() {
dump('abs: removeListener\n');
  if (this.haveABManager)
    var addrbookSession=Components.classes["@mozilla.org/abmanager;1"].
            getService(Components.interfaces.nsIAbManager);
  else
    var addrbookSession = Components.classes["@mozilla.org/addressbook/services/session;1"].
            getService(Components.interfaces.nsIAddrBookSession);
  addrbookSession.removeAddressBookListener(sessionListener);
}

var sessionListener = {
  abs: null,

  // these functions are called for the main dir and every list (which has been shown
  // in the addressbookwindows) even if item are not part of the list
//After book has been downloaded vie replace by entry, these functions
//are no longer called for dir (only for lists)
  onItemAdded: function(parentDir, item) {
    try {
      var dir=parentDir.QueryInterface(Components.interfaces.nsIAbDirectory);
      if (item instanceof Components.interfaces.nsIAbCard) {
        var card=item.QueryInterface(Components.interfaces.nsIAbCard);
        var db=this.abs.getDB(dir);  //since TB3 necessary for (see below)
        //card might be a list
        var nd=Math.round(Date.now()/1000);
dump('abs: item added parent='+dir.dirName+' email='+card.primaryEmail+'\n');
//dump('     lmd of dir,card set from '+dir.lastModifiedDate+','+card.getCardValue('LastModifiedDate')+' to '+nd+'\n');
dump('     lmd of dir,card set from '+dir.lastModifiedDate+','+db.getCardValue(card, 'LastModifiedDate')+' to '+nd+'\n');
        dir.lastModifiedDate=nd;
//TB3 hat kein card.getCardValue, nur nsIAddrDatabase.getCardValue(card, prop)
//        card.setCardValue('LastModifiedDate',nd);
        db.setCardValue(card, 'LastModifiedDate',nd, false);
      }
    } catch(e) { dump('abs Listener (item added '+item+'): '+e+'\n'); }
  },
  onItemRemoved: function(parentDir, item) {
    try {
var now=Math.round(Date.now()/1000);
dump('abs: remove item time='+now+'\n');
      var dir=parentDir.QueryInterface(Components.interfaces.nsIAbDirectory);
      if (item instanceof Components.interfaces.nsIAbCard) {
        var nd=Math.round(Date.now()/1000);
var card=item.QueryInterface(Components.interfaces.nsIAbCard);
dump('abs: card removed parent='+dir.dirName+' email='+card.primaryEmail+'\n');
dump('     lmd of dir set from '+dir.lastModifiedDate+' to '+nd+'\n');
        dir.lastModifiedDate=nd; //is necessary!
      } else if (item instanceof Components.interfaces.nsIAbDirectory) {
        var list=item.QueryInterface(Components.interfaces.nsIAbDirectory);
        if (!dir.dirName) {
// Dies kommt dummerweise bevor...
dump('abs: book removed book='+list.dirName+'\n');
        } else {
// ...diese kommen
dump('abs: list removed parent='+dir.dirName+' list='+list.dirName+'\n');
          // hhm, wie unterscheide ich, ob es nur ein l�schen der Liste
          // ist, oder ein l�schen des ganzen Buches?
          // Vielleicht ist es auch egal?
//          dir.lastModifiedDate=Math.round(Date.now()/1000);
        }
dump('     lmd of dir is '+dir.lastModifiedDate+'\n');
      } else {
dump('abs: ??? removed parent='+dir.dirName+'\n');
      }
    } catch(e) { dump('abs Listener (item deleted): '+e+'\n'); }
  },
  onItemPropertyChanged: function(item, property, oldValue, newValue) {
var now=Math.round(Date.now()/1000);
dump('abs: property change time='+now+'\n');
    //property, oldValue and newValue are always null
    if (item instanceof Components.interfaces.nsIAbCard) {
      //e.g. called when card added to a list (with property, old and new Value = null)
      var card=item.QueryInterface(Components.interfaces.nsIAbCard);
dump('card changed '+card.primaryEmail+' '+property+': '+oldValue+'->'+newValue+'\n');
    // this also sets the lastModifiedDate on the card
    } else if (item instanceof Components.interfaces.nsIAbDirectory) {
      var dir=item.QueryInterface(Components.interfaces.nsIAbDirectory);
dump('dir changed '+dir.dirName+' '+property+': '+oldValue+'->'+newValue+'\n');
    } else {
dump('abs: ??? changed item='+item+'\n');
    }
dump('     lmd of dir is '+dir.lastModifiedDate+'\n');
  }
};

function getDir(special) {
/*
  var profileFolder = directoryService.get(special,  Components.interfaces.nsIFile);
  var profileDir = profileFolder.QueryInterface(Components.interfaces.nsILocalFile);
  var nsIMabFile = profileDir.clone().QueryInterface(Components.interfaces.nsILocalFile);
*/
  var dir = this.directoryService.get(special,  Components.interfaces.nsIFile)
    .QueryInterface(Components.interfaces.nsILocalFile);
//  return dir.clone().QueryInterface(Components.interfaces.nsILocalFile);
  return dir;
}

/*
 *  Read a mab file and return the data
 */
function readMabData(nsIMabFile, addLastMod)
{
  if (!nsIMabFile.exists()) return '';

  var fs = Components.classes['@mozilla.org/network/file-input-stream;1']
          .createInstance(Components.interfaces.nsIFileInputStream);
  var ss = Components.classes['@mozilla.org/scriptableinputstream;1']
          .createInstance(Components.interfaces.nsIScriptableInputStream);
  var str='';
  try{
    fs.init(nsIMabFile, 0x01, 0, false);
    ss.init(fs);
    str = ss.read(-1);
    ss.close();
    fs.close();
  } catch(e){ this.promptService.alert(null, 'readMabData', 'readMabData:\n'+e); }
//    return str;
  if (addLastMod) {
    var lmt=new Date(nsIMabFile.lastModifiedTime);
    return str.replace(/-->[^\r\n]*/,'--> '+lmt);//append to the // <!-- <mdb:mork:z v="1.4"/> -->
  } else
    return str;
}

/*
 *  Save Data to a mab File
 */
function writeMabData(nsIMabFile, abData)
{
  try {
    if (nsIMabFile.exists() && nsIMabFile.isFile()) nsIMabFile.remove(false);
    var strm = Components.classes["@mozilla.org/network/file-output-stream;1"].
      createInstance(Components.interfaces.nsIFileOutputStream);
    strm.QueryInterface(Components.interfaces.nsIOutputStream);
    strm.QueryInterface(Components.interfaces.nsISeekableStream);
    strm.init( nsIMabFile, 0x20|0x02|0x08, /*0600*/0x180, 0 );
      // 0x02=PR_WRONLY, 0x08=PR_CREATE_FILE, 0x20=PR_TRUNCATE
    strm.write( abData, abData.length );
    strm.flush();
    strm.close();
  } catch(e) {
      this.promptService.alert(null, 'writeMabData', 'File write error of '+nsIMabFile.target+'\n'+e);
      return null;
  }
  return nsIMabFile;
}

/*
 *  This is, where every up-/download starts!
 */
function showPopup(direction, singlebook, usepopup, automatic, force)
{
  //singlebook: a mabFile or null
  //usepopup: if true, use popups, else ask property 'hidepopups'
  //automatic: true, if its an automatic down-/upload and programmstart/-end
  //force: if true, upload mabs, even if not changed
  if (this.synctype=='none') return;
  if (direction=='upload' && this.noupload) return;
  if (!singlebook && this.syncedAddressbooks((direction=='download')?'down':'up',null).Count()==0)
    return;  //nothing to do

//TODO: possible race condition!
  if (this.state!='') {  // we are already doing an up-/download
    if (!automatic)
      this.promptService.alert(null, 'showPopup', this.strings.GetStringFromName('inprogress'));
    return;
  }

  this.usesPopup=usepopup || !this.hideallpopups;
//  if (!usepopup) hidepopups = this.gABS.hidepopups;

  this.state=direction;

this.debug('showPopup usesPopup='+this.usesPopup);
  if (!this.usesPopup) {
    var windowsEnum = this.wMediator.getEnumerator(null);  //enumerate all windows //"mail:3pane");
    while (windowsEnum.hasMoreElements()) {
      var w=windowsEnum.getNext();
      if (w.de.ggbs.abs.upload) break;
      w=null;
    }
    if (!w) {
this.debug('showPopup: no Window!');
      this.promptService.alert(null, 'showPopup', 'no window to perform up-/download!');
      this.state='';
    } else{
this.debug('showPopup: show');
      if (direction=='download') w.de.ggbs.abs.download(singlebook, force);    //in download.js
      else                       w.de.ggbs.abs.upload(singlebook, force);      //in upload.js
    }
  } else {
/*
    var w=window.openDialog("chrome://addressbookssync/content/"+direction+".xul","_blank",
      'chrome,resizable,titlebar=no', singlebook, force);
*/
    var args = Components.classes["@mozilla.org/supports-array;1"]
                    .createInstance(Components.interfaces.nsISupportsArray);
    var s=Components.classes["@mozilla.org/supports-string;1"]
        .createInstance(Components.interfaces.nsISupportsString);
    s.data=singlebook;
    args.AppendElement(s);
    var f=Components.classes["@mozilla.org/supports-string;1"]
        .createInstance(Components.interfaces.nsISupportsString);
    f.data=force?'true':'false';
    args.AppendElement(f);
    var modal='';
    if (this.noDirProp && this.exiting && this.synctype=='imap') {  //TB3 only!
      modal=',modal';
/*
      if (this.lastWindow) this.lastWindow.minimize();
      var windowsEnum = this.wMediator.getEnumerator(null);  //enumerate all windows //"mail:3pane");
      while (windowsEnum.hasMoreElements()) {
        var w=windowsEnum.getNext();
        w.minimize();
      }
*/
      this.debug('showPopup: openmodal');
    }
    var w=this.wWatcher.openWindow(null, "chrome://addressbookssync/content/"+direction+".xul",
      '_blank', 'chrome,resizable,titlebar=no'+modal, args);
    //if adding more arguments: update in call to upload() and download() above
    //    AND in upload.xul and download.xul!!
this.debug('showPopup: opened '+w);
  }
}

function debug(text) {
return;
  var d=new Date();
  var s=d.toLocaleFormat('%d.%b.%Y %H:%M:%S');
  text=s+': '+text+'\n';
  var flags=0x10|0x08|0x02;
        // 0x02=PR_WRONLY, 0x10=PR_APPEND, 0x08=PR_CREATE_FILE
  try {
    var logFile = this.getDir('TmpD');
    logFile.appendRelativePath( 'AddressbookSynchronizer.log' );
    var strm = Components.classes["@mozilla.org/network/file-output-stream;1"].
      createInstance(Components.interfaces.nsIFileOutputStream);
    strm.QueryInterface(Components.interfaces.nsIOutputStream);
    strm.QueryInterface(Components.interfaces.nsISeekableStream);
    strm.init( logFile, flags, /*0600*/0x180, 0 );
    strm.write( text, text.length );
    strm.flush();
    strm.close();
  } catch(e) { console.logStringMessage('AddressbooksSynchronizer: '+'File write:\n'+e+'\n'); }
}
