/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AddressbooksSynchronizer.
 *
 * The Initial Developer of the Original Code is Günter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Günter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

de.ggbs.abs.gSingleBook=null;
de.ggbs.abs.gMabFile=null;
de.ggbs.abs.gMabName=null;

de.ggbs.abs.externalApp=null;
de.ggbs.abs.externalAppHandler=null;

de.ggbs.abs.downloadDone=function() {
  if (de.ggbs.abs.gSingleBook) alert(de.ggbs.abs.gStrings.getString('loaded'));
  de.ggbs.abs.refreshAddressbook();

  var w=null;
  if (!de.ggbs.abs.abs_init) {
    var windowsEnum = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService()
                   .QueryInterface(Components.interfaces.nsIWindowMediator).
                   getEnumerator('de-ggbs-abs-options');  //enumerate option windows
    var w=windowsEnum.getNext();
  } else w=window;
  if (w) w.de.ggbs.abs.abs_init(); // update options list, if necessary

}
de.ggbs.abs.remoteDownloadDone=function() {
  if (!de.ggbs.abs.gABS.noexternalappset) {
  //alert('app='+de.ggbs.abs.externalApp+' handler='+de.ggbs.abs.externalAppHandler);
    if (de.ggbs.abs.externalApp) {
      var syncprotocol = de.ggbs.abs.gABS.protocol;
      if (de.ggbs.abs.externalApp==-1)
        de.ggbs.abs.pref.clearUserPref("network.protocol-handler.external."+syncprotocol);
      else
        de.ggbs.abs.pref.setBoolPref("network.protocol-handler.external."+syncprotocol, true);
    }
    if (de.ggbs.abs.externalAppHandler)
      de.ggbs.abs.pref.setCharPref("network.protocol-handler.app."+syncprotocol, de.ggbs.abs.externalAppHandler);
    de.ggbs.abs.externalApp=null;
    de.ggbs.abs.externalAppHandler=null;
  }
  de.ggbs.abs.downloadDone();
}
de.ggbs.abs.localDownloadDone=function() {
  de.ggbs.abs.downloadDone();
}

//TODO: welche Addressbücher sind auf dem Server zu finden!?
de.ggbs.abs.download=function(singleBook, force)
{
//dump('in download appstart='+de.ggbs.abs.gABS.appstarttime+' state='+de.ggbs.abs.gABS.state+'\n');
  if (typeof(force) == 'object') {  //called via openWindow()
    singleBook=singleBook.data;
    force=force.data=='true';
  } else if (typeof(force) == 'string') { //when does this happen?
    force=force=='true';
  }
  de.ggbs.abs.gLifeTime=3;
  de.ggbs.abs.gForce=force||de.ggbs.abs.gABS.forceDownload;
    de.ggbs.abs.gABS.forceDownload=false;
  var synctype=de.ggbs.abs.gABS.synctype;

  if (de.ggbs.abs.gABS.usesPopup) {
//    window.moveTo(0,0);
      //v could be removed in next version!
        var dialogElement = document.documentElement;
        dialogElement.removeAttribute("persist");
        dialogElement.removeAttribute("height");
        dialogElement.removeAttribute("width");
        dialogElement.removeAttribute("screenX");
        dialogElement.removeAttribute("screenY");
      //^
  }

  de.ggbs.abs.statustxt(synctype, -1, false, 'Start download ('+synctype+')');

  de.ggbs.abs.gABS.count=0;
  de.ggbs.abs.gSingleBook=singleBook;
  de.ggbs.abs.gMabs=de.ggbs.abs.gABS.syncedAddressbooks('down', singleBook);
  if (synctype=='local') {
    de.ggbs.abs.gTempName='abstemp.mab';
    de.ggbs.abs.cleanUp=de.ggbs.abs.localDownloadDone;
    if (de.ggbs.abs.gABS.usesPopup) setTimeout(de.ggbs.abs.getLocalData, 0);  // need time to show the popup
    else de.ggbs.abs.getLocalData();
  } else if (synctype=='remote') {
    de.ggbs.abs.gTempName='abstemp.mab';
    if (!de.ggbs.abs.gABS.noexternalappset) {
      var syncprotocol = de.ggbs.abs.gABS.protocol;
//dump('setting de.ggbs.abs.externalApp preferences for '+syncprotocol+'\n');
      try { de.ggbs.abs.externalApp=de.ggbs.abs.pref.getBoolPref("network.protocol-handler.external."+syncprotocol); }
        catch(e) { de.ggbs.abs.externalApp=-1; }
      if (de.ggbs.abs.externalApp) de.ggbs.abs.pref.setBoolPref("network.protocol-handler.external."+syncprotocol, false);
      //ubuntu seems to ignore the value of external.xxx, therefore:
      try {
        de.ggbs.abs.externalAppHandler=de.ggbs.abs.pref.getCharPref("network.protocol-handler.app."+syncprotocol);
        if (de.ggbs.abs.externalAppHandler) de.ggbs.abs.pref.clearUserPref("network.protocol-handler.app."+syncprotocol);
      } catch(e) { de.ggbs.abs.externalAppHandler=''; }
    }
    de.ggbs.abs.cleanUp=de.ggbs.abs.remoteDownloadDone;
    if (de.ggbs.abs.gABS.usesPopup) setTimeout(de.ggbs.abs.getData, 0);
    else de.ggbs.abs.getData();
  } else if (synctype=='imap') {
    if (de.ggbs.abs.gABS.usesPopup) setTimeout(de.ggbs.abs.imapLoad, 0);
    else de.ggbs.abs.imapLoad();
  } else {
    de.ggbs.abs.killMe();
  }
}

de.ggbs.abs.getLocalData=function() {
  var localpath=de.ggbs.abs.gABS.localpath;
  if (!localpath) { //preferences not set!
    de.ggbs.abs.killMe();
    return;
  }
  var path = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
  path.initWithPath( localpath );
  while (de.ggbs.abs.gMabs.Count()>0) {
    if (de.ggbs.abs.gAbort) break;
    dir=de.ggbs.abs.gMabs.GetElementAt(0);
    de.ggbs.abs.gMabs.RemoveElement(dir)
    var mabName;
    var mabFile;
    var externalFilename;
    var newSinglebook;
    if (dir instanceof Components.interfaces.nsIAbDirectory) {
      var dirProp = de.ggbs.abs.gABS.noDirProp?dir:dir.directoryProperties;
      mabName=dir.dirName;
      mabFile=dirProp.fileName;

      if ((de.ggbs.abs.gForce || !de.ggbs.abs.gABS.checkLastModTime) && !de.ggbs.abs.askOverwrite(dir, false)) {
        de.ggbs.abs.statustxt('- '+mabName+" "+de.ggbs.abs.gStrings.getString('skipped'), 3, false);
        continue;
      }
      externalFilename=de.ggbs.abs.gABS.externalFilename(dir);
      newSinglebook=false;
    } else {  // new single book
      mabName = dir.QueryInterface(Components.interfaces.nsISupportsString).data;
      externalFilename = mabName+'.mab';
      mabFile = mabName.replace( /\W/g, "_" )+'.mab';
      newSinglebook=true;
//dump('getLocalData, new single book filename='+externalFilename+'\n');
    }
    de.ggbs.abs.statustxt('- '+mabName+'..', 1, false);

    var file = Components.classes["@mozilla.org/file/local;1"].
      createInstance(Components.interfaces.nsILocalFile);
    file.initWithFile( path );
    file.appendRelativePath( externalFilename );
    if (!file.exists()) {
      de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('nofile'), 2, true, null, file.path);
      continue;
    }

    var lms='';
    if (!newSinglebook) {
      var localMabFile = de.ggbs.abs.gABS.getDir('ProfD');
      localMabFile.appendRelativePath( mabFile );
      var lmfd=de.ggbs.abs.timeString(localMabFile.lastModifiedTime);
      var lfd=de.ggbs.abs.timeString(file.lastModifiedTime);
      lms='lastMod mab:'+lmfd+' file:'+lfd;

      if (!de.ggbs.abs.gForce && de.ggbs.abs.gABS.checkLastModTime) {
        if (localMabFile.lastModifiedTime >= file.lastModifiedTime) {
          de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('skipped'), 2, false, null, lms);
          continue;
        } else if (!de.ggbs.abs.askOverwrite(dir, false)) {
          de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('skipped'), 2, false, null, 'Policy: '+de.ggbs.abs.gABS.downloadpolicy);
          continue;
        }
      }
    }

    var ret;
//    if (externalFilename.substr(-5)=='.ldif' || externalFilename.substr(-4)=='.ldi') {
    if (externalFilename.match(/\.ldif?$/i)) {
      var dir=de.ggbs.abs.gABS.getAddressBook(mabFile);  //dir=nsIAbDirectory
      if (!dir) return 'failed to find addressbook';
dump('---load ldif\n');
//  de.ggbs.abs.statustxt("+", 0, false, null); //
dump('clear addressbook\n');
//de.ggbs.abs.dumpDir(dir, 'At Start:');
      var ret=de.ggbs.abs.gABS.clearAddressBook(dir);
      if (ret)
        de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('notcopied'), 2, true, null, ret);
      else {
//  de.ggbs.abs.statustxt("+", 0, false, null); //
dump('read LDIF\n');
        var observerService=Components.classes["@mozilla.org/observer-service;1"]
          .getService(Components.interfaces.nsIObserverService);
        de.ggbs.abs.LDIFloaded.dir=dir;
        de.ggbs.abs.LDIFloaded.lms=lms;
        de.ggbs.abs.LDIFloaded.os=observerService;
        de.ggbs.abs.LDIFloaded.type='local';
        observerService.addObserver(de.ggbs.abs.LDIFloaded,"LDIFcomplete",false);
        de.ggbs.abs.gABS.LDIFAddressBook(dir, file);
        //loading LDIF is ASYNCHRONOUS!
        return;
      }
    } else {
      if ((ret=de.ggbs.abs.replaceAddressBook(mabName, mabFile, file))) {
        de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('notcopied'), 2, true, null, ret);
      } else {
        de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('copied'), 2, false, null, lms);
        de.ggbs.abs.gABS.count+=1;
//        if (newSinglebook) de.ggbs.abs.abs_init(); // insert in options list
      }
    }
  }
  de.ggbs.abs.killMe();

}
de.ggbs.abs.LDIFloaded = {
  dir: null,
  lms: null,
  os:  null,
  type: null,
  observe: function(subject, topic, status ) {
    if (topic=='LDIFcomplete') {
      var str=subject.QueryInterface( Components.interfaces.nsISupportsString);
dump(topic+': '+status+': '+str); //str ends with '\n'!
      this.os.removeObserver(de.ggbs.abs.LDIFloaded, 'LDIFcomplete' );
      if (status=='failed')
        de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('notcopied'), 2, true, null, str);
      else {
        this.dir.lastModifiedDate=de.ggbs.abs.gABS.appstarttime; //set to 'not modified'
        de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('copied'), 2, false, null, this.lms);
        de.ggbs.abs.gABS.count+=1;
      }
dump('calling next book\n');
      if (this.type=='local') de.ggbs.abs.getLocalData(); //continue with next book
      else if (this.type=='remote'){
        if (de.ggbs.abs.gABS.usesPopup) de.ggbs.abs.getData();  // next addressbook
        else setTimeout(de.ggbs.abs.getData, 1000);
      } else {
        if (de.ggbs.abs.gABS.usesPopup) setTimeout(de.ggbs.abs.imapLoadNextBook, 0);
        else de.ggbs.abs.imapLoadNextBook();
      }
    }
else dump('LDIFloaded: unknown topic '+topic+'\n');
  }
};

de.ggbs.abs.getData=function()
{
  if (de.ggbs.abs.gAbort) {
    de.ggbs.abs.killMe();
    return;
  }
  if (!de.ggbs.abs.checkOffline('download')) return;


  if (!de.ggbs.abs.gMabs.Count()) {
    de.ggbs.abs.killMe();
    return;
  }

  var dir=de.ggbs.abs.gMabs.GetElementAt(0);
  de.ggbs.abs.gMabs.RemoveElement(dir);
  var externalFilename;
  var newSinglebook;
  if (dir instanceof Components.interfaces.nsIAbDirectory) {
    var dirProp = de.ggbs.abs.gABS.noDirProp?dir:dir.directoryProperties;
    de.ggbs.abs.gMabName=dir.dirName;
    de.ggbs.abs.gMabFile=dirProp.fileName;

    if ((de.ggbs.abs.gForce || !de.ggbs.abs.gABS.checkLastModTime) && !de.ggbs.abs.askOverwrite(dir, false)) {
        de.ggbs.abs.statustxt('- '+de.ggbs.abs.gMabName+" "+de.ggbs.abs.gStrings.getString('skipped'), 3, false);
        de.ggbs.abs.getData();
        return;
    }

    externalFilename=de.ggbs.abs.gABS.externalFilename(dir);
    newSinglebook=false;
  } else {  // new single book
    de.ggbs.abs.gMabName = dir.QueryInterface(Components.interfaces.nsISupportsString).data;
    externalFilename=de.ggbs.abs.gMabName+'.mab';
    de.ggbs.abs.gMabFile = de.ggbs.abs.gMabName.replace( /\W/g, "_" )+'.mab';
    newSinglebook=true;
//dump('getData, new single book filename='+externalFilename+'\n');
  }
  if (!de.ggbs.abs.gMabName || de.ggbs.abs.gMabName=='false') {  //Merkw�rdiger Fehler (Lars Wohlfahrt, 16.6.08)
    de.ggbs.abs.statustxt('MabName='+de.ggbs.abs.gMabName+' dir='+dir+' single='+newSinglebook, 3, false);
    de.ggbs.abs.getData();  // next addressbook
  }
  de.ggbs.abs.statustxt('- '+de.ggbs.abs.gMabName+".", 1, false);  // 1. dot: start

  var mabURI=de.ggbs.abs.getSyncURI(false)+externalFilename;
  var ioService=Components.classes["@mozilla.org/network/io-service;1"]
                 .getService(Components.interfaces.nsIIOService);
  try {//There has been a case, where the 'FTP' was missing (Markus Buscher <blackpanther.online@gmx.de>)
    var URI=ioService.newURI(mabURI,null,null);
  } catch(e) {
    alert('Internal error: URI incomplete');
    de.ggbs.abs.killMe();
    return;
  }

/*
  var protService=Components.classes["@mozilla.org/uriloader/external-protocol-service;1"]
               .getService(Components.interfaces.nsIExternalProtocolService);
  //Windows: from Registry HKCR\ftp\shell\open\command
  //Unix:    form preferences network.protocol-handler.app.
  if (protService.externalProtocolHandlerExists(URI.scheme)) {
    alert('external Protocol handler for '+URI.scheme+': '+
      protService.getApplicationDescription(URI.scheme));
  }
*/

  var flmt=null;
  if (!newSinglebook) {
    var f=de.ggbs.abs.gForce;
    if (!de.ggbs.abs.gForce && de.ggbs.abs.gABS.checkLastModTime) {
      //check for last modified date on download
      var localMabFile = de.ggbs.abs.gABS.getDir('ProfD');
      localMabFile.appendRelativePath( de.ggbs.abs.gMabFile );
      flmt=new Date(localMabFile.lastModifiedTime);
    }
  //wenn keine ausgabe der lastmod time: forcierter download!!
  }
  var s=flmt?'lastMod mabfile:'+de.ggbs.abs.timeString(flmt):null;
  de.ggbs.abs.statustxt(".", 0, false, null, s); // 2. dot: start of download
  var error=de.ggbs.abs.gDownloadService.start(
    URI, de.ggbs.abs.downloadCallback, de.ggbs.abs.gABS.usepost, flmt, dir);
  if(error)
    de.ggbs.abs.downloadCallback("done", error);
  else
    de.ggbs.abs.statustxt(".", 0, false); // 3. dot: download started
}

de.ggbs.abs.downloadCallback=function(aStatus, aError, httpStatusText)
{
  if(aStatus != "done" && aError==0)
    return;

  switch(aError){
    case -2:
      return;
      break;
    case 0:
      //aError==0, if we have a file (not, if a error page was returned!)
      var s=de.ggbs.abs.gDownloadService.remoteLastModTime?
        'lastMod remote: '+de.ggbs.abs.timeString(de.ggbs.abs.gDownloadService.remoteLastModTime)
        :null;
      de.ggbs.abs.statustxt(".", 0, false, null, s); // 4. dot: download complete
      try {
        var abData=de.ggbs.abs.gDownloadService.data;
        //mab data must start with: // <!-- <mdb:mork:z v="1.4"/> -->
        if (abData.substr( 0, 19 )=='// <!-- <mdb:mork:z') {
//reinsert probably missing second line (workaround a bug up to 0.8.2)
var i=abData.search(/[\r\n]</);
if (i>200) { //must reinsert!
abData=abData.replace(/([\r\n]+)/,'$1< <(a=c)> // (f=iso-8859-1)$1');
}
          var nsITmpFile = de.ggbs.abs.gABS.getDir('TmpD');
          nsITmpFile.appendRelativePath( de.ggbs.abs.gTempName );
          de.ggbs.abs.gABS.writeMabData(nsITmpFile, abData);
          de.ggbs.abs.statustxt(".", 0, false); // 5. dot: file written
          var err=de.ggbs.abs.replaceAddressBook(de.ggbs.abs.gMabName, de.ggbs.abs.gMabFile, nsITmpFile);
          if (err) {
            de.ggbs.abs.statustxt(err, 2, true);
            break;
          }
          de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('copied'), 2, false);
          de.ggbs.abs.gABS.count+=1;
        } else if (           //check for ldif file
              abData.indexOf('\ndn:')>=0 ||
              abData.indexOf('\nobjectclass:')>=0 ||
              abData.indexOf('\nsn:')>=0 ||
              abData.indexOf('\ncn:')>=0 ||
              abData.indexOf('\ngivenname:')>=0 ||
              abData.indexOf('\nmail:')>=0) {  //seems to be a ldif file
            var nsITmpFile = de.ggbs.abs.gABS.getDir('TmpD');
            nsITmpFile.appendRelativePath( de.ggbs.abs.gTempName );
            de.ggbs.abs.gABS.writeMabData(nsITmpFile, abData);
            de.ggbs.abs.statustxt(".", 0, false); // 5. dot: file written

            var dir=de.ggbs.abs.gABS.getAddressBook(de.ggbs.abs.gMabFile);  //dir=nsIAbDirectory
            if (!dir) {
              de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('notcopied'), 2, true, null, 'Dir not found');
              break;
            }
            var ret=de.ggbs.abs.gABS.clearAddressBook(dir);
            if (ret) {
              de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('notcopied'), 2, true, null, ret);
              break;
            }
            var observerService=Components.classes["@mozilla.org/observer-service;1"]
              .getService(Components.interfaces.nsIObserverService);
            de.ggbs.abs.LDIFloaded.dir=dir;
            de.ggbs.abs.LDIFloaded.lms='';
            de.ggbs.abs.LDIFloaded.os=observerService;
            de.ggbs.abs.LDIFloaded.type='remote';
            observerService.addObserver(de.ggbs.abs.LDIFloaded,"LDIFcomplete",false);
            de.ggbs.abs.gABS.LDIFAddressBook(dir, nsITmpFile);
            //loading LDIF is ASYNCHRONOUS!
            return; //do not break!
        } else { // some unknown fileformat
dump('---download failed, neither mab nor ldif, file start is '+abData.substr( 0, 200 )+'\n');
          de.ggbs.abs.statustxt('Unknown file format', 2, true);
          de.ggbs.abs.gLifeTime=5;//a little bit longer 
        }
      } catch(e) {
        if(e && e.toString().match(/^absync\:(.+)$/))
          de.ggbs.abs.statustxt(RegExp.$1, 2, true);
      }
      break;
    case 0x804b0002: // NS_BINDING_ABORTED: Download stopped because of timecheck
      var s=de.ggbs.abs.gDownloadService.remoteLastModTime?
        'lastMod remote: '+de.ggbs.abs.timeString(de.ggbs.abs.gDownloadService.remoteLastModTime)
        :'Policy: '+de.ggbs.abs.gABS.downloadpolicy;
      de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('skipped'), 2, false, null, s);
      break;
    default:
//dump(aError+': '+httpStatusText+'\n');
      if (httpStatusText)
        de.ggbs.abs.statustxt(de.ggbs.abs.errorstr(aError), 2, true, null, httpStatusText);
      else if (aError)
        de.ggbs.abs.statustxt(de.ggbs.abs.errorstr(aError), 2, true);
      else
        de.ggbs.abs.statustxt(de.ggbs.abs.gStrings.getString('failed'), 2, true);
      de.ggbs.abs.gLifeTime=5;//a little bit longer
      break;
  }
  if (de.ggbs.abs.gABS.usesPopup) de.ggbs.abs.getData();  // next addressbook
  else setTimeout(de.ggbs.abs.getData, 1000);
}

de.ggbs.abs.cancelDownload=function ()
{
  if (de.ggbs.abs.gAbort) {
    de.ggbs.abs.gABS.state=''; //Up-/Download ready
    de.ggbs.abs.gAbort++;
    de.ggbs.abs.killMe();
  } else {
    de.ggbs.abs.gAbort++;
    document.getElementById("abs_cancel").label='kill';
  }
  //de.ggbs.abs.gDownloadService.cancel(); //No, or we may left behind with corrupt mabs
}


